//       Title: Print Job Manager V1.24
//  Written by: John White <yoingco>

#include <commctrl.h>  // This adds Windows.h, which in turn adds Win.h
#include <stdio.h>
#include <winspool.h>
#include <buttonex.h>  // This next include, from John Findlay`s excellent wlib.lib Library,
                       // should be copied into your Include folder. Also. Copy wlib.lib into
                       // your lib folder and then link this program with winspool.lib and
                       // wlib.lib.

#define	IDAPPLICON 710
#define LVM_GETHOTITEM 4157
#define PLATFORM_WIN32 0
#define PLATFORM_WIN32_WINDOWS 1
#define PLATFORM_WIN32_NT 2
#define PLATFORM_WIN32_CE 3

HINSTANCE handle_Instance;
HCURSOR cursor_Handle;
HWND wnd0Ptr,sbw0Ptr,lv0Ptr;
HWND btnPtrs[10];
HMENU menu;
HMENU submenu[5];
JOB_INFO_2 job_i2[1000];
JOB_INFO_2 job2;
HDC prt_dc;
LV_ITEM lvi;
HANDLE prt_Handle;
BOOL timer0_status=FALSE,timer1_status=FALSE,timer2_status=FALSE,timer3_status=FALSE;

char *days[7]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
char *months[12]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

unsigned int oldtp=12,curtp=12,olddt=18,curdt=18,deltime=4,mseconds=3000;
int timer0_Handle=0,timer1_Handle=0,timer2_Handle=0,timer3_Handle=0,oldjobs=0,totjobs=0,curjobs=0;
unsigned long rtn=0,rtnval=0;
char prt_error=0,prt_opened=0,tc0=0,tc1=0,tc2=0,tc3=0,ttmode=1,pmode=1,fmode=1,bmode=0;
char oldps=0,curps=0,uds=0,pps=0,pms=0,mmbp=0,deskmode=2;
char prt_name[50];
char port_name[50];
char driver_name[50];
char udjstg[8][30];
char udsstg[8][30];

LRESULT CALLBACK wnd0Procedure(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);

BOOL InitApplication(void);
HWND create_window(void);
HWND create_listview(int,int,int,int);
HWND create_button(int,int,int,int,char *,DWORD,char);
HWND create_statusbar(void);
BOOL create_tooltip(char,char *);
void get_winver(void);
void timer0_off(void);
void timer0_on(void);
void timer0_code(void);
void timer1_off(void);
void timer1_on(void);
void timer1_code(void);
void timer2_off(void);
void timer2_on(void);
void timer2_code(void);
void timer3_off(void);
void timer3_on(void);
void timer3_code(void);
void create_menu(void);
void create_cursor(void);
void open_printer(void);
void enum_jobs2(void);
void get_job2(DWORD);
void update_status(void);
void update_lb(void);
void pause_status(char);
void delete_oldjobs(void);
void pause_job(void);
void resume_job(void);
void print_job(void);
void delete_job(void);
void pause_all(void);
void resume_all(void);
void print_all(void);
void delete_all(void);
void print_cursel(DWORD);
void pause_printer(void);
void resume_printer(void);
void close_printer(void);
void delete_dc(void);
void load_settings(char *);
void save_settings(char *);
void hover_time(int);

BOOL InitApplication(void)
{
WNDCLASS wc0;
memset(&wc0,0,sizeof(WNDCLASS));
wc0.style=CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS|CS_BYTEALIGNCLIENT|CS_BYTEALIGNWINDOW;
wc0.lpfnWndProc=(WNDPROC)wnd0Procedure;
wc0.hInstance=handle_Instance;
wc0.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
wc0.lpszClassName="JWW0";
wc0.lpszMenuName=NULL;
wc0.hCursor=LoadCursor(NULL,IDC_ARROW);
wc0.hIcon=LoadIcon(handle_Instance,MAKEINTRESOURCE(IDAPPLICON));
if (!RegisterClass(&wc0))
return FALSE;
return TRUE;
}

HWND create_window(void)
{
RECT dtrect;
HWND desktop=0;
int w=800,h=444;
desktop=GetDesktopWindow();
rtn=GetWindowRect(desktop,&dtrect);
if (rtn==TRUE)
{
if (dtrect.right==640)
{
w=640;
h=445;
deskmode=1;
}
else if (dtrect.right==1024)
{
w=1024;
h=553;
deskmode=3;
}
else if (dtrect.right==1152)
{
w=1152;
h=642;
deskmode=4;
}
}
return CreateWindowEx(0,"JWW0","  Print Job Manager V1.24       Written by: Yoingco",
WS_SYSMENU|WS_MINIMIZEBOX|WS_CAPTION|WS_CLIPSIBLINGS|WS_CLIPCHILDREN,0,0,w,h,NULL,NULL,handle_Instance,NULL);
}

HWND create_listview(int x,int y,int w,int h)
{
return CreateWindowEx(0,WC_LISTVIEW,"",WS_VISIBLE|WS_CHILD|WS_BORDER|LVS_REPORT|LVS_SHOWSELALWAYS,x,y,w,h,wnd0Ptr,NULL,handle_Instance,NULL);
}

HWND create_button(int x,int y,int w,int h,char *title,DWORD bid,char row)
{
int gap=0;
if (deskmode==1)
{
gap=2;
}
else if (deskmode==3)
{
y=y+88;
gap=4;
}
else if (deskmode==4)
{
y=y+154;
gap=6;
}
if ((gap) && (row==1))
y=y+gap;
return CreateButtonEx(title,BXS_LITE|BXS_BORDER,x,y,w,h,wnd0Ptr,bid);
}

HWND create_statusbar(void)
{
return CreateStatusWindow(WS_CHILD|WS_VISIBLE|WS_BORDER,"",wnd0Ptr,0);
}

HWND CreateListBoxEx(DWORD dwExStyle,DWORD dwStyle,int x,int y,int cx,int cy,HWND hWndParent,int numcols,DWORD ctrlID);

LRESULT CALLBACK wnd0Procedure(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
HDC hdc;
PAINTSTRUCT ps;
RECT rect;
COLORREF colour;
HGDIOBJ sbrush;
UINT menuitem=0;
UINT cstate;
NMHDR *nmh;
NM_LISTVIEW *nmlv;
int counter=0;
char stgbuf[256];

switch (msg)
{

case WM_PAINT:
colour=GetSysColor(COLOR_ACTIVECAPTION);
hdc=BeginPaint(wnd0Ptr,&ps);
if (hdc)
{
rtn=GetClientRect(wnd0Ptr,&rect);
if (rtn==TRUE)
{
rtn=SetBkMode(hdc,OPAQUE);
if (rtn)
{
rtn=SetBkColor(hdc,colour);
if (rtn!=CLR_INVALID)
{
rtn=SetTextColor(hdc,0x00FFFFFF);
if (rtn!=CLR_INVALID)
{
sbrush=CreateSolidBrush(colour);
if (sbrush)
{
rtn=FillRect(hdc,&rect,sbrush);
if (rtn==TRUE)
{

}
rtn=DeleteObject(sbrush);
}
}
}
}
}
rtn=EndPaint(wnd0Ptr,&ps);
}
return 0;

case WM_COMMAND:
menuitem=LOWORD(wParam);
if ((menuitem>0) && (menuitem<14))
{
oldtp=curtp;
curtp=menuitem;
if (curtp!=oldtp)
{
CheckMenuItem(submenu[4],oldtp,MF_BYCOMMAND|MF_UNCHECKED);
CheckMenuItem(submenu[4],curtp,MF_BYCOMMAND|MF_CHECKED);
mseconds=(250*menuitem);
if (menuitem==13)
mseconds=1;
timer3_off();
timer3_on();
}
break;
}
else if ((menuitem>14) && (menuitem<23))
{
olddt=curdt;
curdt=menuitem;
if (curdt!=olddt)
{
CheckMenuItem(submenu[3],olddt,MF_BYCOMMAND|MF_UNCHECKED);
CheckMenuItem(submenu[3],curdt,MF_BYCOMMAND|MF_CHECKED);
deltime=(menuitem-14);
}
break;
}
else if (menuitem==24)
{
cstate=GetMenuState(submenu[3],menuitem,MF_BYCOMMAND);
if (MF_CHECKED & cstate)
{
pmode=0;
CheckMenuItem(submenu[3],menuitem,MF_BYCOMMAND|MF_UNCHECKED);
}
else
{
pmode=1;
CheckMenuItem(submenu[3],menuitem,MF_BYCOMMAND|MF_CHECKED);
}
break;
}
else if (menuitem==30)
{
cstate=GetMenuState(submenu[2],menuitem,MF_BYCOMMAND);
if (MF_CHECKED & cstate)
{
fmode=0;
CheckMenuItem(submenu[2],menuitem,MF_BYCOMMAND|MF_UNCHECKED);
}
else
{
fmode=1;
CheckMenuItem(submenu[2],menuitem,MF_BYCOMMAND|MF_CHECKED);
}
break;
}
else if (menuitem==32)
{
timer3_off();
timer2_off();
timer1_off();
timer0_off();
break;
}
else if (menuitem==33)
{
timer0_on();
timer1_on();
timer2_on();
timer3_on();
break;
}
else if (menuitem==35)
{
timer3_off();
timer2_off();
timer1_off();
timer0_off();
delete_dc();
close_printer();
rtn=SendMessage(lv0Ptr,LVM_DELETEALLITEMS,0,0);
if (rtn==TRUE)
{
open_printer();
pause_printer();
enum_jobs2();
totjobs=curjobs;
delete_oldjobs();
pause_status(0);
update_status();
timer0_on();
timer1_on();
timer2_on();
timer3_on();
}
break;
}
else if (menuitem==44)
{
cstate=GetMenuState(submenu[1],menuitem,MF_BYCOMMAND);
if (MF_CHECKED & cstate)
{
ttmode=0;
CheckMenuItem(submenu[1],menuitem,MF_BYCOMMAND|MF_UNCHECKED);
}
else
{
ttmode=1;
CheckMenuItem(submenu[1],menuitem,MF_BYCOMMAND|MF_CHECKED);
}
break;
}
else if (menuitem==46)
{
cstate=GetMenuState(submenu[1],menuitem,MF_BYCOMMAND);
if (MF_CHECKED & cstate)
{
bmode=0;
CheckMenuItem(submenu[1],menuitem,MF_BYCOMMAND|MF_UNCHECKED);
}
else
{
bmode=1;
CheckMenuItem(submenu[1],menuitem,MF_BYCOMMAND|MF_CHECKED);
}
break;
}
else if (menuitem==55)
{
save_settings("PJM.Settings");
break;
}
else if (menuitem==300)
{
print_all();
return 0;
}
else if (menuitem==301)
{
delete_all();
return 0;
}
else if (menuitem==302)
{
pause_all();
return 0;
}
else if (menuitem==303)
{
resume_all();
return 0;
}
else if (menuitem==304)
{
print_job();
return 0;
}
else if (menuitem==305)
{
delete_job();
return 0;
}
else if (menuitem==306)
{
pause_job();
return 0;
}
else if (menuitem==307)
{
resume_job();
return 0;
}
else if (menuitem==308)
{
pause_printer();
return 0;
}
else if (menuitem==309)
{
resume_printer();
return 0;
}
break;

case WM_NOTIFY:
nmh=(NMHDR *)lParam;
if (nmh->hwndFrom==lv0Ptr)
{
switch (nmh->code)
{
case NM_DBLCLK:
nmlv=(NM_LISTVIEW *)lParam;
print_cursel(nmlv->iItem);
break;
default:
rtn=SendMessage(lv0Ptr,LVM_GETHOTITEM,0,0);
if (rtn!=-1)
hover_time(rtn);
else
{
strcpy(stgbuf," ");
rtn=SendMessage(sbw0Ptr,SB_SETTEXT,3,(LPARAM)stgbuf);
rtn=SendMessage(sbw0Ptr,SB_SETTEXT,2,(LPARAM)stgbuf);
}
}
}
break;

case WM_SETFOCUS:
SetFocus(lv0Ptr);
return 0;

case WM_SHOWWINDOW:
if (wParam==TRUE)
{

}
break;

case WM_DESTROY:
EnableWindow(wnd0Ptr,FALSE);
ShowWindow(wnd0Ptr,SW_HIDE);
close_printer();
delete_dc();
PostQuitMessage(0);
return 0;

default:
return DefWindowProc(hwnd,msg,wParam,lParam);
}
return 0;
}

void get_winver(void)
{
OSVERSIONINFO osvi;
osvi.dwOSVersionInfoSize=sizeof(osvi);
rtn=GetVersionEx(&osvi);
if (rtn==TRUE)
{
if (osvi.dwPlatformId==PLATFORM_WIN32_WINDOWS)
{
// Windows 95, 98 and ME.
if (osvi.dwMajorVersion==4)
{
if (osvi.dwMinorVersion==10)
{
// Windows 98.
if (osvi.dwBuildNumber==1998)
mmbp=11;
else if ((osvi.dwBuildNumber>1998) && (osvi.dwBuildNumber<2183))
mmbp=12;
else if (osvi.dwBuildNumber>2182)
mmbp=13;
else
mmbp=201;
}
else if (osvi.dwMinorVersion<10)
{
// Windows 95.
if (osvi.dwBuildNumber==950)
mmbp=1;
else if ((osvi.dwBuildNumber>950) && (osvi.dwBuildNumber<1081))
mmbp=2;
else if (osvi.dwBuildNumber>1080)
mmbp=3;
else
mmbp=200;
}
else if (osvi.dwMinorVersion==90)
{
// Windows ME.
if (osvi.dwBuildNumber==3000)
mmbp=21;
else
mmbp=202;
}
else
mmbp=228;
}
else
mmbp=227;
}
else if (osvi.dwPlatformId==PLATFORM_WIN32_NT)
{
// Windows NT, XP and 2000.
if (osvi.dwMajorVersion==3)
{
// Windows NT 3.51.
if (osvi.dwMinorVersion==51)
{
if (osvi.dwBuildNumber==1057)
mmbp=31;
else
mmbp=203;
}
else
mmbp=226;
}
else if (osvi.dwMajorVersion==4)
{
// Windows NT 4.
if (osvi.dwMinorVersion==0)
{
if (osvi.dwBuildNumber==1381)
mmbp=41;
else
mmbp=204;
}
else
mmbp=225;
}
else if (osvi.dwMajorVersion==5)
{
// Windows 2000 / XP.
if (osvi.dwMinorVersion==0)
{
if (osvi.dwBuildNumber==2195)
// Windows 2000/2000Pro.
mmbp=51;
else
mmbp=205;
}
else if (osvi.dwMinorVersion==1)
// XP.
mmbp=61;
else
mmbp=223;
}
else
mmbp=224;
}
else if (osvi.dwPlatformId==PLATFORM_WIN32_CE)
{
// Pocket Phone, Small Devices, etc.

}
else
mmbp=229;
}
else
mmbp=230;
}

void update_lb(void)
{
//rtn=LockWindowUpdate(lv0Ptr);
//if (rtn=TRUE);
//{
rtn=SendMessage(lv0Ptr,LVM_DELETEALLITEMS,0,0);
if (rtn==TRUE)
enum_jobs2();
//rtn=LockWindowUpdate(NULL);
//}
}

void delete_dc(void)
{
if (prt_dc)
{
if (DeleteDC(prt_dc))
prt_dc=0;
}
}

void close_printer(void)
{
if (prt_Handle)
{
if (ClosePrinter(prt_Handle))
prt_Handle=0;
}
}

void pause_printer(void)
{
if (prt_opened==1)
{
prt_error=1;
rtn=SetPrinter(prt_Handle,0,0,PRINTER_CONTROL_PAUSE);
if (rtn==TRUE)
{
prt_error=0;
pps=0;
}
}
}

void resume_printer(void)
{
if (prt_opened==1)
{
prt_error=1;
rtn=SetPrinter(prt_Handle,0,0,PRINTER_CONTROL_RESUME);
if (rtn==TRUE)
{
prt_error=0;
pps=1;
}
}
}

void pause_all(void)
{
int counter=0;
pms=1;
if ((prt_opened==1) && (curjobs>0))
{
pause_printer();
for (counter=0;counter<curjobs;counter++)
{
get_job2(job_i2[counter].JobId);
if ((job2.Status & JOB_STATUS_PRINTING) || (job2.Status & JOB_STATUS_SPOOLING) || (job2.Status==0))
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_PAUSE);
if (rtn==TRUE)
{

}
}
}
update_status();
}
}

void resume_all(void)
{
int counter=0;
pms=1;
if ((prt_opened==1) && (curjobs>0))
{
pause_printer();
for (counter=0;counter<curjobs;counter++)
{
get_job2(job_i2[counter].JobId);
if (job2.Status & JOB_STATUS_PAUSED)
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME);
if (rtn==TRUE)
{

}
}
}
update_status();
}
}

void print_all(void)
{
int counter=0;
pms=1;
if ((prt_opened==1) && (curjobs>0))
{
pause_printer();
for (counter=0;counter<curjobs;counter++)
{
get_job2(job_i2[counter].JobId);
if (job2.Status & JOB_STATUS_PAUSED)
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME);
if (rtn==TRUE)
{

}
}
}
update_status();
resume_printer();
}
}

void delete_all(void)
{
pms=1;
if (prt_opened==1)
{
pause_printer();
rtn=SetPrinter(prt_Handle,0,0,PRINTER_CONTROL_PURGE);
if (rtn==TRUE)
update_lb();
}
}

void get_job2(DWORD jobid)
{
JOB_INFO_2 *job_info;
DWORD needed=0;
int counter=0;
if (prt_opened==1)
{
prt_error=1;
rtn=GetJob(prt_Handle,jobid,2,0,0,&needed);
if (rtn==0)
{
rtn=GetLastError();
if (rtn==ERROR_INSUFFICIENT_BUFFER)
{
job_info=(JOB_INFO_2 *)GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,needed);
if (job_info!=NULL)
{
rtn=GetJob(prt_Handle,jobid,2,(LPBYTE)job_info,needed,&needed);
if (rtn)
{
job2.JobId=job_info[counter].JobId;
job2.pMachineName=job_info[counter].pMachineName;
job2.pUserName=job_info[counter].pUserName;
job2.pDocument=job_info[counter].pDocument;
job2.Status=job_info[counter].Status;
job2.TotalPages=job_info[counter].TotalPages;
job2.Size=job_info[counter].Size;
job2.Submitted=job_info[counter].Submitted;
job2.PagesPrinted=job_info[counter].PagesPrinted;
prt_error=0;
}
GlobalFree(job_info);
}
}
}
}
}

void pause_job(void)
{
int counter=0,start=-1,selected=-1;
pms=2;
if ((prt_opened==1) && (curjobs>0))
{
pause_printer();
for (counter=0;counter<curjobs;counter++)
{
selected=SendMessage(lv0Ptr,LVM_GETNEXTITEM,(WPARAM)start,(LPARAM)LVNI_SELECTED);
if (selected!=-1)
{
start=selected;
get_job2(job_i2[selected].JobId);
if ((job2.Status & JOB_STATUS_PRINTING) || (job2.Status & JOB_STATUS_SPOOLING) || (job2.Status==0))
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_PAUSE);
if (rtn==TRUE)
{

}
}
}
}
update_status();
}
}

void resume_job(void)
{
int counter=0,start=-1,selected=-1;
pms=2;
if ((prt_opened==1) && (curjobs>0))
{
pause_printer();
for (counter=0;counter<curjobs;counter++)
{
selected=SendMessage(lv0Ptr,LVM_GETNEXTITEM,(WPARAM)start,(LPARAM)LVNI_SELECTED);
if (selected!=-1)
{
start=selected;
get_job2(job_i2[selected].JobId);
if (job2.Status & JOB_STATUS_PAUSED)
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME);
if (rtn==TRUE)
{

}
}
}
}
update_status();
}
}

void print_job(void)
{
int counter=0,start=-1,selected=-1;
if ((prt_opened==1) && (curjobs>0))
{
pause_all();
pms=2;
for (counter=0;counter<curjobs;counter++)
{
selected=SendMessage(lv0Ptr,LVM_GETNEXTITEM,(WPARAM)start,(LPARAM)LVNI_SELECTED);
if (selected!=-1)
{
start=selected;
get_job2(job_i2[selected].JobId);
if (job2.Status & JOB_STATUS_PAUSED)
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME);
if (rtn==TRUE)
{

}
}
}
}
update_status();
resume_printer();
}
}

void delete_job(void)
{
int counter=0,start=-1,selected=-1;
pms=2;
if ((prt_opened==1) && (curjobs>0))
{
pause_printer();
for (counter=0;counter<curjobs;counter++)
{
selected=SendMessage(lv0Ptr,LVM_GETNEXTITEM,(WPARAM)start,(LPARAM)LVNI_SELECTED);
if (selected!=-1)
{
start=selected;
rtn=SetJob(prt_Handle,job_i2[selected].JobId,0,0,JOB_CONTROL_CANCEL);
if (rtn==TRUE)
{

}
}
}
update_lb();
}
}

void delete_oldjobs(void)
{
SYSTEMTIME endtime;
SYSTEMTIME rtntime;
unsigned long long ftime1,ftime2,fdelta;
int counter=0;
WORD hour=0,min=0,sec=0,total=0;
if ((prt_opened==1) && (curjobs>0))
{
GetSystemTime(&endtime);
for (counter=0;counter<curjobs;counter++)
{
get_job2(job_i2[counter].JobId);
SystemTimeToFileTime(&job2.Submitted,(LPFILETIME)&ftime1);
SystemTimeToFileTime(&endtime,(LPFILETIME)&ftime2);
fdelta=ftime2-ftime1;
FileTimeToSystemTime((LPFILETIME)&fdelta,&rtntime);
hour=(rtntime.wHour*60);
min=rtntime.wMinute;
sec=rtntime.wSecond;
total=((hour+min)/30);
if (total>=deltime)
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_CANCEL);
if (rtn==TRUE)
update_lb();
}
}
}
}

void hover_time(int itemnum)
{
SYSTEMTIME endtime;
SYSTEMTIME rtntime;
unsigned long long ftime1,ftime2,fdelta;
WORD hour=0,min=0,sec=0;
char stgbuf[50];
if ((prt_opened==1) && (curjobs>0))
{
GetSystemTime(&endtime);
get_job2(job_i2[itemnum].JobId);
SystemTimeToFileTime(&job2.Submitted,(LPFILETIME)&ftime1);
SystemTimeToFileTime(&endtime,(LPFILETIME)&ftime2);
fdelta=ftime2-ftime1;
FileTimeToSystemTime((LPFILETIME)&fdelta,&rtntime);
hour=(rtntime.wHour*60);
min=rtntime.wMinute;
sec=rtntime.wSecond;
sprintf(stgbuf," Job: %04d  Hrs: %02d  Mins: %02d  Secs: %02d  ",(1+itemnum),hour,min,sec);
rtn=SendMessage(sbw0Ptr,SB_SETTEXT,3,(LPARAM)stgbuf);
sprintf(stgbuf," Job Total: %04d",curjobs);
rtn=SendMessage(sbw0Ptr,SB_SETTEXT,2,(LPARAM)stgbuf);
}
}

void print_cursel(DWORD cursel)
{
if ((prt_opened==1) && (curjobs>0))
{
pause_all();
pms=0;
get_job2(job_i2[cursel].JobId);
if (job2.Status & JOB_STATUS_PAUSED)
{
rtn=SetJob(prt_Handle,job2.JobId,0,0,JOB_CONTROL_RESUME);
if (rtn==TRUE)
{

}
}
update_status();
resume_printer();
}
}

void update_status(void)
{
int counter=0,count=1;
char *str[8];
if ((prt_opened==1) && (curjobs>0))
{
for (counter=0;counter<curjobs;counter++)
{
get_job2(job_i2[counter].JobId);
sprintf(udsstg[0],job2.pMachineName);
sprintf(udsstg[1],job2.pUserName);
sprintf(udsstg[2],job2.pDocument);
if (job2.Status)
{
if (job2.Status & JOB_STATUS_USER_INTERVENTION)
{
if (job2.Status & JOB_STATUS_PAPEROUT)
{
if (job2.Status & JOB_STATUS_PRINTING)
sprintf(udsstg[3],"PaperOut/Printing");
else if (job2.Status & JOB_STATUS_DELETING)
sprintf(udsstg[3],"PaperOut/Deleting");
else
sprintf(udsstg[3],"PaperOut");
}
else if (job2.Status & JOB_STATUS_OFFLINE)
{
if (job2.Status & JOB_STATUS_PRINTING)
sprintf(udsstg[3],"OffLine/Printing");
else if (job2.Status & JOB_STATUS_DELETING)
sprintf(udsstg[3],"OffLine/Deleting");
else
sprintf(udsstg[3],"OffLine");
}
else
{
if (job2.Status & JOB_STATUS_PRINTING)
sprintf(udsstg[3],"Error/Printing");
else if (job2.Status & JOB_STATUS_DELETING)
sprintf(udsstg[3],"Error/Deleting");
else
sprintf(udsstg[3],"Error");
}
}
else if (job2.Status & JOB_STATUS_SPOOLING)
{
if (job2.Status & JOB_STATUS_PAUSED)
sprintf(udsstg[3],"Spooling/Paused");
else if (job2.Status & JOB_STATUS_DELETING)
sprintf(udsstg[3],"Spooling/Deleting");
else if (job2.Status & JOB_STATUS_ERROR)
sprintf(udsstg[3],"Spooling/Error");
else
sprintf(udsstg[3],"Spooling");
}
else if (job2.Status & JOB_STATUS_PRINTING)
{
if (job2.Status & JOB_STATUS_PAUSED)
sprintf(udsstg[3],"Printing/Paused");
else if (job2.Status & JOB_STATUS_DELETING)
sprintf(udsstg[3],"Printing/Deleting");
else if (job2.Status & JOB_STATUS_ERROR)
sprintf(udsstg[3],"Printing/Error");
else
sprintf(udsstg[3],"Printing");
}
else if (job2.Status & JOB_STATUS_DELETING)
{
if (job2.Status & JOB_STATUS_PAUSED)
sprintf(udsstg[3],"Deleting/Paused");
else if (job2.Status & JOB_STATUS_ERROR)
sprintf(udsstg[3],"Deleting/Error");
else
sprintf(udsstg[3],"Deleting");
}
else if (job2.Status & JOB_STATUS_PAUSED)
{
if (job2.Status & JOB_STATUS_DELETING)
sprintf(udsstg[3],"Paused/Deleting");
else if (job2.Status & JOB_STATUS_ERROR)
sprintf(udsstg[3],"Paused/Error");
else
sprintf(udsstg[3],"Paused");
}
else if (job2.Status & JOB_STATUS_PRINTED)
{
sprintf(udsstg[3],"Printed");
}
else if (job2.Status & JOB_STATUS_DELETED)
{
sprintf(udsstg[3],"Deleted");
}
else if (job2.Status & JOB_STATUS_ERROR)
{
sprintf(udsstg[3],"Error");
}
else if (job2.Status & JOB_STATUS_RESTART)
{
sprintf(udsstg[3],"Restarting");
}
else
sprintf(udsstg[3],"Unknown");
}
else
sprintf(udsstg[3],"Ready");
sprintf(udsstg[4],"%04d",job2.TotalPages);
sprintf(udsstg[5],"%04d",job2.PagesPrinted);
sprintf(udsstg[6],"%02d:%02d:%02d    %s %d %s %4d",(job2.Submitted.wHour),
job2.Submitted.wMinute,job2.Submitted.wSecond,
days[job2.Submitted.wDayOfWeek],job2.Submitted.wDay,
months[(job2.Submitted.wMonth)-1],job2.Submitted.wYear);
sprintf(udsstg[7],"%05d Kb  %02d Mb",(job2.Size/1024),(job2.Size/1024000));
lvi.mask=LVIF_TEXT;
lvi.iItem=0;
lvi.state=0;
lvi.stateMask=0;
lvi.iImage=0;
lvi.lParam=0;
for (count=1;count<8;count++)
{
lvi.iSubItem=count;
lvi.pszText=udsstg[count];
lvi.cchTextMax=sizeof(udsstg[count]);
rtn=SendMessage(lv0Ptr,LVM_SETITEMTEXT,(WPARAM)counter,(LPARAM)&lvi);
}
}
}
}

void enum_jobs2()
{
JOB_INFO_2 *job_info;
DWORD needed=0,returned=0;
int counter=0,count=1;
if (prt_opened==1)
{
prt_error=1;
rtn=EnumJobs(prt_Handle,0,499,2,0,0,&needed,&returned);
if (rtn==0)
{
rtn=GetLastError();
if (rtn==ERROR_INSUFFICIENT_BUFFER)
{
job_info=(JOB_INFO_2 *)GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,needed);
if (job_info!=NULL)
{
rtn=EnumJobs(prt_Handle,0,499,2,(LPBYTE)job_info,needed,&needed,&returned);
if (rtn)
{
curjobs=returned;
for (counter=0;counter<returned;counter++)
{
job_i2[counter].JobId=job_info[counter].JobId;
job_i2[counter].pMachineName=job_info[counter].pMachineName;
job_i2[counter].pUserName=job_info[counter].pUserName;
job_i2[counter].pDocument=job_info[counter].pDocument;
job_i2[counter].Status=job_info[counter].Status;
job_i2[counter].TotalPages=job_info[counter].TotalPages;
job_i2[counter].Size=job_info[counter].Size;
job_i2[counter].Submitted=job_info[counter].Submitted;
job_i2[counter].PagesPrinted=job_info[counter].PagesPrinted;
sprintf(udjstg[0],job_info[counter].pMachineName);
sprintf(udjstg[1],job_info[counter].pUserName);
sprintf(udjstg[2],job_info[counter].pDocument);
if (job_info[counter].Status) {
if (job_info[counter].Status & JOB_STATUS_USER_INTERVENTION)
{
if (job_info[counter].Status & JOB_STATUS_PAPEROUT)
{
if (job_info[counter].Status & JOB_STATUS_PRINTING)
sprintf(udjstg[3],"PaperOut/Printing");
else if (job_info[counter].Status & JOB_STATUS_DELETING)
sprintf(udjstg[3],"PaperOut/Deleting");
else
sprintf(udjstg[3],"PaperOut");
}
else if (job_info[counter].Status & JOB_STATUS_OFFLINE)
{
if (job_info[counter].Status & JOB_STATUS_PRINTING)
sprintf(udjstg[3],"OffLine/Printing");
else if (job_info[counter].Status & JOB_STATUS_DELETING)
sprintf(udjstg[3],"OffLine/Deleting");
else
sprintf(udjstg[3],"OffLine");
}
else
{
if (job_info[counter].Status & JOB_STATUS_PRINTING)
sprintf(udjstg[3],"Error/Printing");
else if (job_info[counter].Status & JOB_STATUS_DELETING)
sprintf(udjstg[3],"Error/Deleting");
else
sprintf(udjstg[3],"Error");
}
}
else if (job_info[counter].Status & JOB_STATUS_SPOOLING)
{
if (job_info[counter].Status & JOB_STATUS_PAUSED)
sprintf(udjstg[3],"Spooling/Paused");
else if (job_info[counter].Status & JOB_STATUS_DELETING)
sprintf(udjstg[3],"Spooling/Deleting");
else if (job_info[counter].Status & JOB_STATUS_ERROR)
sprintf(udjstg[3],"Spooling/Error");
else
sprintf(udjstg[3],"Spooling");
}
else if (job_info[counter].Status & JOB_STATUS_PRINTING)
{
if (job_info[counter].Status & JOB_STATUS_PAUSED)
sprintf(udjstg[3],"Printing/Paused");
else if (job_info[counter].Status & JOB_STATUS_DELETING)
sprintf(udjstg[3],"Printing/Deleting");
else if (job_info[counter].Status & JOB_STATUS_ERROR)
sprintf(udjstg[3],"Printing/Error");
else
sprintf(udjstg[3],"Printing");
}
else if (job_info[counter].Status & JOB_STATUS_DELETING)
{
if (job_info[counter].Status & JOB_STATUS_PAUSED)
sprintf(udjstg[3],"Deleting/Paused");
else if (job_info[counter].Status & JOB_STATUS_ERROR)
sprintf(udjstg[3],"Deleting/Error");
}
else if (job_info[counter].Status & JOB_STATUS_PAUSED)
{
if (job_info[counter].Status & JOB_STATUS_DELETING)
sprintf(udjstg[3],"Paused/Deleting");
else if (job_info[counter].Status & JOB_STATUS_ERROR)
sprintf(udjstg[3],"Paused/Error");
else
sprintf(udjstg[3],"Paused");
}
else if (job_info[counter].Status & JOB_STATUS_PRINTED)
{
sprintf(udjstg[3],"Printed");
}
else if (job_info[counter].Status & JOB_STATUS_DELETED)
{
sprintf(udjstg[3],"Deleted");
}
else if (job_info[counter].Status & JOB_STATUS_ERROR)
{
sprintf(udjstg[3],"Error");
}
else if (job_info[counter].Status & JOB_STATUS_RESTART)
{
sprintf(udjstg[3],"Restarting");
}
else
sprintf(udjstg[3],"Unknown");
}
else
sprintf(udjstg[3],"Ready");
sprintf(udjstg[4],"%04d",job_info[counter].TotalPages);
sprintf(udjstg[5],"%04d",job_info[counter].PagesPrinted);
sprintf(udjstg[6],"%02d:%02d:%02d    %s %d %s %4d",(job_info[counter].Submitted.wHour),
job_info[counter].Submitted.wMinute,job_info[counter].Submitted.wSecond,
days[job_info[counter].Submitted.wDayOfWeek],job_info[counter].Submitted.wDay,
months[(job_info[counter].Submitted.wMonth)-1],job_info[counter].Submitted.wYear);
sprintf(udjstg[7],"%04d",job_info[counter].Size);
lvi.mask=LVIF_TEXT;
lvi.iItem=counter;
lvi.iSubItem=0;
lvi.state=0;
lvi.stateMask=0;
lvi.pszText=udjstg[0];
lvi.cchTextMax=sizeof(udjstg[0]);
lvi.iImage=0;
lvi.lParam=0;
rtn=SendMessage(lv0Ptr,LVM_INSERTITEM,(WPARAM)0,(LPARAM)&lvi);
lvi.iItem=0;
for (count=1;count<8;count++)
{
lvi.iSubItem=count;
lvi.pszText=udjstg[count];
lvi.cchTextMax=sizeof(udjstg[count]);
rtn=SendMessage(lv0Ptr,LVM_SETITEMTEXT,(WPARAM)counter,(LPARAM)&lvi);
}
}
prt_error=0;
}
GlobalFree(job_info);
}
}
}
else
{
curjobs=0;
prt_error=0;
}
}
}

void pause_status(char sts)
{
PRINTER_INFO_2 *prt_info;
DWORD needed=0;
char stgbuf[256];
if (prt_opened==1)
{
prt_error=1;
rtn=GetPrinter(prt_Handle,2,0,0,&needed);
if (rtn==0)
{
rtn=GetLastError();
if (rtn==ERROR_INSUFFICIENT_BUFFER)
{
prt_info=(PRINTER_INFO_2 *)GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,needed);
if (prt_info!=NULL)
{
rtn=GetPrinter(prt_Handle,2,(LPBYTE)prt_info,needed,&needed);
if (rtn)
{
prt_error=0;
lstrcpy(stgbuf," Printer Status:  ");
if (prt_info[0].Status & PRINTER_STATUS_PAUSED)
{
lstrcat(stgbuf,"Paused");
oldps=curps;
curps=1;
}
else
{
lstrcat(stgbuf,"UnPaused");
oldps=curps;
curps=0;
}
if ((oldps!=curps) || (sts==0))
rtn=SendMessage(sbw0Ptr,SB_SETTEXT,0,(LPARAM)stgbuf);
}
GlobalFree(prt_info);
}
}
}
}
}

void open_printer(void)
{
PRINTER_DEFAULTS prt_defaults;
char stgbuf[120];
char *printer, *driver, *port;
prt_error=1;
GetProfileString("windows","device",",,,",stgbuf,120);
if ((printer=strtok(stgbuf,(const char *) ",")) &&
    (driver=strtok((char *) NULL,(const char *) ", ")) &&
    (port=strtok((char *) NULL,(const char *) ", ")))
strcpy(prt_name,printer);
strcpy(port_name,port);
strcpy(driver_name,driver);
prt_defaults.pDatatype=NULL;
prt_defaults.pDevMode=0;
prt_defaults.DesiredAccess=PRINTER_ALL_ACCESS;
if (OpenPrinter(prt_name,&prt_Handle,&prt_defaults))
{
prt_opened=1;
prt_dc=CreateDC(NULL,prt_name,NULL,0);
if (prt_dc)
{
prt_error=0;
strcpy(stgbuf," Default Printer:  ");
strcat(stgbuf,prt_name);
rtn=SendMessage(sbw0Ptr,SB_SETTEXT,1,(LPARAM)stgbuf);
}
}
}

void create_menu(void)
{
MENUITEMINFO mi[5];
MENUITEMINFO si[55];
int counter=0;
si[54].dwTypeData="Save Settings";
si[53].dwTypeData="";
si[52].dwTypeData="";
si[51].dwTypeData="";
si[50].dwTypeData="";
si[49].dwTypeData="";
si[48].dwTypeData="";
si[47].dwTypeData="";
si[46].dwTypeData="";
si[45].dwTypeData="Create/Use Coloured Buttons";
si[44].dwTypeData="";
si[43].dwTypeData="Create/Use Button ToolTips ";
si[42].dwTypeData="";
si[41].dwTypeData="";
si[40].dwTypeData="";
si[39].dwTypeData="";
si[38].dwTypeData="";
si[37].dwTypeData="";
si[36].dwTypeData="";
si[35].dwTypeData="";
si[34].dwTypeData="Get The Default Printer ";
si[33].dwTypeData="";
si[32].dwTypeData="Start Print Job Manager ";
si[31].dwTypeData="Stop Print Job Manager  ";
si[30].dwTypeData="";
si[29].dwTypeData="ALWAYS Pause the Printer";
si[28].dwTypeData="";
si[27].dwTypeData="";
si[26].dwTypeData="";
si[25].dwTypeData="";
si[24].dwTypeData="";
si[23].dwTypeData="READY All Jobs After A Double-Click Print";
si[22].dwTypeData="";
si[21].dwTypeData="Auto-Delete OLD Jobs after         4 Hours ";
si[20].dwTypeData="Auto-Delete OLD Jobs after      3 Hours   ";
si[19].dwTypeData="Auto-Delete OLD Jobs after         3 Hours ";
si[18].dwTypeData="Auto-Delete OLD Jobs after      2 Hours   ";
si[17].dwTypeData="Auto-Delete OLD Jobs after         2 Hours ";
si[16].dwTypeData="Auto-Delete OLD Jobs after      1 Hours   ";
si[15].dwTypeData="Auto-Delete OLD Jobs after         1 Hour  ";
si[14].dwTypeData="Auto-Delete OLD Jobs after       30 Minutes";
si[13].dwTypeData="";
si[12].dwTypeData=" Fastest     ";
si[11].dwTypeData="  3   Seconds";
si[10].dwTypeData="2  Seconds  ";
si[9].dwTypeData="2  Seconds  ";
si[8].dwTypeData="2  Seconds  ";
si[7].dwTypeData="  2   Seconds";
si[6].dwTypeData="1  Seconds  ";
si[5].dwTypeData="1  Seconds  ";
si[4].dwTypeData="1  Seconds  ";
si[3].dwTypeData="   1  Second ";
si[2].dwTypeData="    Second  ";
si[1].dwTypeData="    Second  ";
si[0].dwTypeData="    Second  ";
for (counter=0;counter<55;counter++)
{
si[counter].cbSize=sizeof(MENUITEMINFO);
si[counter].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE|MIIM_CHECKMARKS;
si[counter].fType=MFT_STRING;
si[counter].fState=MFS_ENABLED|MFS_UNCHECKED;
si[counter].wID=1+counter;
si[counter].hSubMenu=NULL;
si[counter].hbmpChecked=NULL;
si[counter].hbmpUnchecked=NULL;
si[counter].dwItemData=0;
si[counter].cch=0;
}
si[44].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE;
si[44].fType=MFT_SEPARATOR;
si[44].fState=MFS_ENABLED;
si[33].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE;
si[33].fType=MFT_SEPARATOR;
si[33].fState=MFS_ENABLED;
si[30].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE;
si[30].fType=MFT_SEPARATOR;
si[30].fState=MFS_ENABLED;
si[22].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE;
si[22].fType=MFT_SEPARATOR;
si[22].fState=MFS_ENABLED;
if (bmode==1)
si[45].fState=si[45].fState|MFS_CHECKED;
if (ttmode==1)
si[43].fState=si[43].fState|MFS_CHECKED;
if (fmode==1)
si[29].fState=si[29].fState|MFS_CHECKED;
if (pmode==1)
si[23].fState=si[23].fState|MFS_CHECKED;
si[(curdt-1)].fState=si[(curdt-1)].fState|MFS_CHECKED;
si[(curtp-1)].fState=si[(curtp-1)].fState|MFS_CHECKED;
if (submenu[0]=CreateMenu())
{
if (InsertMenuItem(submenu[0],0,TRUE,&si[54]))
{

}
}
if (submenu[1]=CreateMenu())
{
for (counter=43;counter<46;counter++)
{
if (InsertMenuItem(submenu[1],0,TRUE,&si[counter]))
{

}
}
}
if (submenu[2]=CreateMenu())
{
for (counter=29;counter<35;counter++)
{
if (InsertMenuItem(submenu[2],0,TRUE,&si[counter]))
{

}
}
}
if (submenu[3]=CreateMenu())
{
for (counter=14;counter<22;counter++)
{
if (InsertMenuItem(submenu[3],0,TRUE,&si[counter]))
{

}
}
}
if (submenu[4]=CreateMenu())
{
for (counter=0;counter<13;counter++)
{
if (InsertMenuItem(submenu[4],0,TRUE,&si[counter]))
{

}
}
}
mi[4].dwTypeData="  Update Speed ";
mi[3].dwTypeData="  Job Options ";
mi[2].dwTypeData="  Printer Options ";
mi[1].dwTypeData="  Startup Options ";
mi[0].dwTypeData="  File ";
for (counter=0;counter<5;counter++)
{
mi[counter].cbSize=sizeof(MENUITEMINFO);
mi[counter].fMask=MIIM_ID|MIIM_STATE|MIIM_TYPE|MIIM_SUBMENU;
mi[counter].fType=MFT_STRING;
mi[counter].fState=MFS_ENABLED;
mi[counter].wID=200+counter;
mi[counter].hSubMenu=submenu[counter];
mi[counter].hbmpChecked=NULL;
mi[counter].hbmpUnchecked=NULL;
mi[counter].dwItemData=0;
}
if (menu=CreateMenu())
{
for (counter=0;counter<5;counter++)
{
if (InsertMenuItem(menu,0,TRUE,&mi[counter]))
{

}
}
}
}

void create_cursor(void)
{
// 1 = TRANSPARENT
BYTE ANDmask[] =
{
0xF9,0xFF,0xFF,0xFF,
0xF0,0xFF,0xFF,0xFF,
0xF0,0xFF,0xFF,0xFF,
0xF0,0xFF,0xFF,0xFF,
0xF0,0xFF,0xFF,0xFF,
0xF0,0xFF,0xFF,0xFF,
0xF0,0xFF,0xFF,0xFF,
0xF0,0xFF,0xFF,0xFF,
0xF0,0x3F,0xFF,0xFF,
0xF0,0x07,0xFF,0xFF,
0xF0,0x03,0xFF,0xFF,
0xF0,0x00,0xFF,0xFF,
0x90,0x00,0x7F,0xFF,
0x00,0x00,0x7F,0xFF,
0x00,0x00,0x7F,0xFF,
0x80,0x00,0x7F,0xFF,
0xC0,0x00,0x7F,0xFF,
0xC0,0x00,0x7F,0xFF,
0xE0,0x00,0x7F,0xFF,
0xE0,0x00,0xFF,0xFF,
0xF0,0x00,0xFF,0xFF,
0xF0,0x00,0xFF,0xFF,
0xF8,0x01,0xFF,0xFF,
0xF8,0x01,0xFF,0xFF,
0xFC,0x03,0xFF,0xFF,
0xFC,0x03,0xFF,0xFF,
0xFC,0x03,0xFF,0xFF,
0xFC,0x03,0xFF,0xFF,
0xFF,0xFF,0xFF,0xFF,
0xFF,0xFF,0xFF,0xFF,
0xFF,0xFF,0xFF,0xFF,
0xFF,0xFF,0xFF,0xFF,
};

// 1 = WHITE
BYTE XORmask[] =
{
0x00,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0x00,0x00,0x00,
0x06,0xC0,0x00,0x00,
0x06,0xD8,0x00,0x00,
0x06,0xD8,0x00,0x00,
0x06,0xDB,0x00,0x00,
0x66,0xDB,0x00,0x00,
0x77,0xFB,0x00,0x00,
0x37,0xFF,0x00,0x00,
0x1F,0xFF,0x00,0x00,
0x1F,0xFF,0x00,0x00,
0x0F,0xFF,0x00,0x00,
0x0F,0xFE,0x00,0x00,
0x07,0xFE,0x00,0x00,
0x07,0xFE,0x00,0x00,
0x03,0xFC,0x00,0x00,
0x03,0xFC,0x00,0x00,
0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,
};

cursor_Handle=CreateCursor(handle_Instance,6,0,32,32,ANDmask,XORmask);
}

void timer0_on(void)
{
if (timer0_status==FALSE)
{
timer0_Handle=SetTimer(0,0,1,(TIMERPROC)timer0_code);
if (timer0_Handle)
timer0_status=TRUE;
}
}

void timer0_off(void)
{
if (timer0_status==TRUE)
{
if (KillTimer(NULL,timer0_Handle))
timer0_status=FALSE;
}
}

void timer0_code(void)
{
HANDLE chgObj;
DWORD changed=0;
char stg[17];
if (tc0==0)
{
tc0=1;
chgObj=FindFirstPrinterChangeNotification(prt_Handle,PRINTER_CHANGE_JOB,0,NULL);
if (chgObj)
{
rtnval=WaitForSingleObject(chgObj,500);
if (rtnval==WAIT_FAILED)
{

}
else
{
if (rtnval==WAIT_TIMEOUT)
{
if (uds==1)
{
uds=0;
if ((fmode==1) && (pps==1) && (pms==0))
pause_printer();
update_lb();
}
}
else if (rtnval==WAIT_ABANDONED)
{

}
else if (rtnval==WAIT_OBJECT_0)
{
if (FindNextPrinterChangeNotification(chgObj,&changed,NULL,NULL))
{
uds=1;
if (changed & PRINTER_CHANGE_WRITE_JOB)
{
// A Job has been Added.
if ((fmode==1) && (pps==1) && (pms==0))
pause_printer();
update_lb();
}
else if (changed & PRINTER_CHANGE_ADD_JOB)
{
// A Job has been Added.
if ((fmode==1) && (pps==1) && (pms==0))
pause_printer();
update_lb();
}
else if (changed & PRINTER_CHANGE_DELETE_JOB)
{
// A Job has been Deleted.
update_lb();
}
else if (changed & PRINTER_CHANGE_SET_JOB)
{
// This could be anything. A Job has been Printed, Paused, Deleted etc.
if (changed & PRINTER_CHANGE_WRITE_JOB)
{
if ((fmode==1) && (pps==1) && (pms==0))
pause_printer();
update_lb();
}
else if (changed & PRINTER_CHANGE_ADD_JOB)
{
if ((fmode==1) && (pps==1) && (pms==0))
pause_printer();
update_lb();
}
else if (changed & PRINTER_CHANGE_DELETE_JOB)
{
// A Job has been Deleted.
update_lb();
}
// Other Messages Go Here.
}
}
}
}
if (FindClosePrinterChangeNotification(chgObj))
tc0=0;
}
}
}

void timer1_on(void)
{
if (timer1_status==FALSE)
{
timer1_Handle=SetTimer(0,0,400,(TIMERPROC)timer1_code);
if (timer1_Handle)
timer1_status=TRUE;
}
}

void timer1_off(void)
{
if (timer1_status==TRUE)
{
if (KillTimer(NULL,timer1_Handle))
timer1_status=FALSE;
}
}

void timer1_code(void)
{
if (tc1==0)
{
tc1=1;
pause_status(1);
tc1=0;
}
}

void timer2_on(void)
{
if (timer2_status==FALSE)
{
timer2_Handle=SetTimer(0,0,3000,(TIMERPROC)timer2_code);
if (timer2_Handle)
timer2_status=TRUE;
}
}

void timer2_off(void)
{
if (timer2_status==TRUE)
{
if (KillTimer(NULL,timer2_Handle))
timer2_status=FALSE;
}
}

void timer2_code(void)
{
if (tc2==0)
{
tc2=1;
delete_oldjobs();
tc2=0;
}
}

void timer3_on(void)
{
if (timer3_status==FALSE)
{
timer3_Handle=SetTimer(0,0,mseconds,(TIMERPROC)timer3_code);
if (timer3_Handle)
timer3_status=TRUE;
}
}

void timer3_off(void)
{
if (timer3_status==TRUE)
{
if (KillTimer(NULL,timer3_Handle))
timer3_status=FALSE;
}
}

void timer3_code(void)
{
if (tc3==0)
{
tc3=1;
if (curjobs>0)
update_status();
tc3=0;
}
}

BOOL create_tooltip(char ttNumber,char *textTT)
{
INITCOMMONCONTROLSEX iccex;
TOOLINFO ti;
HWND handle_ToolTip;
iccex.dwICC=ICC_WIN95_CLASSES;
iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
InitCommonControlsEx(&iccex);
handle_ToolTip=CreateWindowEx(WS_EX_TOPMOST,TOOLTIPS_CLASS,NULL,
WS_POPUP|TTS_NOPREFIX|TTS_ALWAYSTIP,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
wnd0Ptr,NULL,handle_Instance,NULL);
if (handle_ToolTip)
{
SetWindowPos(handle_ToolTip,HWND_TOPMOST,0,100,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
ti.cbSize=sizeof(TOOLINFO);
ti.uFlags=TTF_SUBCLASS;
ti.hwnd=btnPtrs[ttNumber];
ti.hinst=handle_Instance;
ti.uId=0;
ti.lpszText=textTT;
ti.rect.left=0;
ti.rect.top=0;
ti.rect.right=115;
ti.rect.bottom=23;
if ((ttNumber>3) && (ttNumber<8))
ti.rect.right=153;
else if (ttNumber>7)
ti.rect.right=125;
rtn=SendMessage(handle_ToolTip,TTM_ADDTOOL,0,(LPARAM)(LPTOOLINFO) &ti);
rtn=SendMessage(handle_ToolTip,TTM_SETMAXTIPWIDTH,0,300);
return TRUE;
}
return FALSE;
}

void save_settings(char *filename)
{
FILE *settings;
int character=0;
char stgbuf[17];
settings=fopen(filename,"wb");
if (settings!=NULL)
{
sprintf(stgbuf,"%04d",curtp);
character=fputs(stgbuf,settings);
if (character!=EOF)
{
character=fputc(pmode,settings);
if (character!=EOF)
{
sprintf(stgbuf,"%04d",curdt);
character=fputs(stgbuf,settings);
if (character!=EOF)
{
character=fputc(fmode,settings);
if (character!=EOF)
{
character=fputc(ttmode,settings);
if (character!=EOF)
{
character=fputc(bmode,settings);
if (character!=EOF)
{

}
}
}
}
}
}
character=fclose(settings);
if (character!=EOF)
{

}
else
{
// File did not Close.
}
}
else
{
// file did not open.
}
}

void load_settings(char *filename)
{
FILE *settings;
int character=0,fsize=0,position=0;
char stgbuf[17];
// Open the File.
settings=fopen(filename,"rb");
if (settings!=NULL)
{
// Get the file Size.
character=fgetc(settings);
while (character!=EOF)
{
position++;
character=fgetc(settings);
}
fsize=position;
if (fsize==12)
{
// Calculate/Convert the data.
rtn=fseek(settings,0,SEEK_SET);
if (rtn==0)
{
if (fgets(stgbuf,5,settings))
{
curtp=atoi(stgbuf);
if ((curtp<1) || (curtp>13))
curtp=13;
oldtp=curtp;
mseconds=(250*curtp);
if (curtp==13)
mseconds=1;
pmode=fgetc(settings);
if ((pmode<0) || (pmode>1))
pmode=1;
if (fgets(stgbuf,5,settings))
{
curdt=atoi(stgbuf);
if ((curdt<15) || (curdt>22))
curdt=18;
olddt=curdt;
deltime=(curdt-14);
fmode=fgetc(settings);
if ((fmode<0) || (fmode>1))
fmode=1;
ttmode=fgetc(settings);
if ((ttmode<0) || (ttmode>1))
ttmode=1;
bmode=fgetc(settings);
if ((bmode<0) || (bmode>1))
bmode=1;

}
}
}
}
else
{
// file size error.
}
character=fclose(settings);
if (character!=EOF)
{

}
else
{
// file did not close.
}
}
else
{
// file don`t exist.
}
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,INT nCmdShow)
{
MSG msg;
HANDLE mutex_handle;
HDC hdc;
HGDIOBJ oldfont,curfont;
LV_COLUMN lvc;
int counter=0,width=0,height=0;
int ptArray[4];
int collen[8];
char stgbuf[256];
char colname[8][30];
char txt0[ ]="Print ALL Jobs.";
char txt1[ ]="Delete ALL Jobs.\n\nThe Currently Printing Job Cannot Be Deleted.";
char txt2[ ]="Pause ALL Jobs.\n\nAvoid Accidental Printing!";
char txt3[ ]="Ready (Prepare) ALL Jobs For Printing.";
char txt4[ ]="Print The Selected Jobs.";
char txt5[ ]="Delete The Selected Jobs.\n\nThe Currently Printing Job Cannot Be Deleted.";
char txt6[ ]="Pause The Selected Jobs.\n\nAvoiding Accidental Printing.";
char txt7[ ]="Ready (Prepare) The Selected Jobs For Printing.";
char txt8[ ]="Pause The Printer.\n\nSuspend Printing Of Any More Jobs.";
char txt9[ ]="UnPause The Printer.\n\nMake The Printer Ready For Printing.";
handle_Instance=hInstance;
mutex_handle=CreateMutex(NULL,TRUE,"PJM");
if (mutex_handle)
{
rtn=GetLastError();
if (rtn!=ERROR_ALREADY_EXISTS)
{

InitCommonControls();

rtn=InitApplication();
if (rtn==1)
{
load_settings("PJM.Settings");
create_cursor();
create_menu();

wnd0Ptr=create_window();
if (wnd0Ptr)
{

if (deskmode==1)
{
lv0Ptr=create_listview(0,0,634,299);
}
else if (deskmode==3)
lv0Ptr=create_listview(0,0,1018,383);
else if (deskmode==4)
lv0Ptr=create_listview(0,0,1146,445);
else
lv0Ptr=create_listview(0,0,794,298);
if (lv0Ptr)
{

if (deskmode==1)
{
strcpy(colname[0],"  Computer");
strcpy(colname[1],"     Owner");
strcpy(colname[2],"Document Name");
strcpy(colname[3],"   Status");
strcpy(colname[4]," Page/s");
strcpy(colname[5],"Printed");
strcpy(colname[6],"   Submitted Time/Date");
strcpy(colname[7],"  Buffer Size");
collen[0]=71;
collen[1]=75;
collen[2]=94;
collen[3]=62;
collen[4]=55;
collen[5]=47;
collen[6]=133;
collen[7]=79;
ptArray[0]=160;
ptArray[1]=342;
ptArray[2]=445;
ptArray[3]=632;
}
else if (deskmode==3)
{
strcpy(colname[0]," Computer Name");
strcpy(colname[1],"       Owner");
strcpy(colname[2],"        Document Name");
strcpy(colname[3],"       Status");
strcpy(colname[4]," Page/s");
strcpy(colname[5]," Printed");
strcpy(colname[6],"       Submitted Time/Date");
strcpy(colname[7],"       Buffer Size");
collen[0]=123;
collen[1]=111;
collen[2]=182;
collen[3]=109;
collen[4]=65;
collen[5]=66;
collen[6]=201;
collen[7]=138;
ptArray[0]=210;
ptArray[1]=584;
ptArray[2]=716;
ptArray[3]=1016;
}
else if (deskmode==4)
{
strcpy(colname[0]," Computer Name");
strcpy(colname[1],"       Owner");
strcpy(colname[2],"         Document Name");
strcpy(colname[3],"        Status");
strcpy(colname[4]," Page/s");
strcpy(colname[5]," Printed");
strcpy(colname[6],"      Submitted Time/Date");
strcpy(colname[7],"      Buffer Size");
collen[0]=150;
collen[1]=119;
collen[2]=210;
collen[3]=125;
collen[4]=73;
collen[5]=74;
collen[6]=218;
collen[7]=148;
ptArray[0]=236;
ptArray[1]=658;
ptArray[2]=806;
ptArray[3]=1144;
}
else
{
strcpy(colname[0],"Computer Name");
strcpy(colname[1],"      Owner");
strcpy(colname[2],"         Document Name");
strcpy(colname[3],"       Status");
strcpy(colname[4]," Page/s");
strcpy(colname[5]," Printed");
strcpy(colname[6],"      Submitted Time/Date");
strcpy(colname[7],"       Buffer Size");
collen[0]=94;
collen[1]=81;
collen[2]=148;
collen[3]=86;
collen[4]=55;
collen[5]=53;
collen[6]=151;
collen[7]=107;
ptArray[0]=164;
ptArray[1]=449;
ptArray[2]=556;
ptArray[3]=792;
}
for (counter=0;counter<8;counter++)
{
lvc.mask=LVCF_FMT|LVCF_WIDTH|LVCF_TEXT|LVCF_SUBITEM;
lvc.fmt=LVCFMT_LEFT;
lvc.cx=collen[counter];
lvc.pszText=colname[counter];
lvc.cchTextMax=sizeof(colname[counter]);
lvc.iSubItem=counter;
rtn=SendMessage(lv0Ptr,LVM_INSERTCOLUMN,(WPARAM)counter,(LPARAM)&lvc);
if (rtn==-1)
{

}
}
rtn=SendMessage(lv0Ptr,LVM_SETBKCOLOR,(WPARAM)0,(LPARAM)(COLORREF)0x00FFFFFF);
rtn=SendMessage(lv0Ptr,LVM_SETTEXTBKCOLOR,(WPARAM)0,(LPARAM)(COLORREF)0x00FFFFFF);
rtn=SendMessage(lv0Ptr,LVM_SETEXTENDEDLISTVIEWSTYLE,(WPARAM)0,(LPARAM)LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT|LVS_EX_TWOCLICKACTIVATE);

if (menu)
SetMenu(wnd0Ptr,menu);

hdc=GetDC(wnd0Ptr);
if (hdc)
{
curfont=CreateFont(20,7,1,1,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_DONTCARE,"Arial");
oldfont=SelectObject(hdc,curfont);
ReleaseDC(wnd0Ptr,hdc);
}

btnPtrs[0]=create_button(6,311,116,24,"Print All Jobs",300,0);
if (btnPtrs[0])
{
btnPtrs[1]=create_button(131,311,116,24,"Delete All Jobs",301,0);
if (btnPtrs[1])
{
btnPtrs[2]=create_button(6,343,116,24,"Pause All Jobs",302,1);
if (btnPtrs[2])
{
btnPtrs[3]=create_button(131,343,116,24,"Ready All Jobs",303,1);
if (btnPtrs[3])
{
btnPtrs[4]=create_button(471,311,154,24,"Print Selected Jobs",304,0);
if (btnPtrs[4])
{
btnPtrs[5]=create_button(634,311,154,24,"Delete Selected Jobs",305,0);
if (btnPtrs[5])
{
btnPtrs[6]=create_button(471,343,154,24,"Pause Selected Jobs",306,1);
if (btnPtrs[6])
{
btnPtrs[7]=create_button(634,343,154,24,"Ready Selected Jobs",307,1);
if (btnPtrs[7])
{
btnPtrs[8]=create_button(303,311,126,24,"Pause Printer",308,0);
if (btnPtrs[8])
{
btnPtrs[9]=create_button(303,343,126,24,"UnPause Printer",309,1);
if (btnPtrs[9])
{

if (curfont)
{
for (counter=0;counter<10;counter++)
rtn=SendMessage(btnPtrs[counter],WM_SETFONT,(WPARAM)curfont,FALSE);
if (bmode==1)
{
for (counter=0;counter<4;counter++)
{
Butx_SetTextColor(btnPtrs[counter],0x005555FF);
Butx_SetTextColor(btnPtrs[(6+counter)],0x00444444);
Butx_SetTextColor(btnPtrs[(4+counter)],0x00FF8822);
}
}
}

sbw0Ptr=create_statusbar();
if (sbw0Ptr)
{
rtn=SendMessage(sbw0Ptr,SB_SETPARTS,4,(LPARAM)(LPINT)ptArray);
strcpy(stgbuf," ");
rtn=SendMessage(sbw0Ptr,SB_SETTEXT,2,(LPARAM)stgbuf);
}

if (ttmode==1)
{
if (create_tooltip(0,txt0))
{
if (create_tooltip(1,txt1))
{
if (create_tooltip(2,txt2))
{
if (create_tooltip(3,txt3))
{
if (create_tooltip(4,txt4))
{
if (create_tooltip(5,txt5))
{
if (create_tooltip(6,txt6))
{
if (create_tooltip(7,txt7))
{
if (create_tooltip(8,txt8))
{
if (create_tooltip(9,txt9))
{

}
}
}
}
}
}
}
}
}
}
}

if (cursor_Handle)
{
if (SetClassLong(wnd0Ptr,GCL_HCURSOR,(LONG)cursor_Handle))
{
for (counter=0;counter<10;counter++)
{
if (SetClassLong(btnPtrs[counter],GCL_HCURSOR,(LONG)cursor_Handle))
{

}
}
}
}

open_printer();
if (prt_opened==1)
{
if (prt_dc)
{

pause_printer();
enum_jobs2();
totjobs=curjobs;
delete_oldjobs();
pause_status(0);
timer0_on();
timer1_on();
timer2_on();
timer3_on();
ShowWindow(wnd0Ptr,nCmdShow);
UpdateWindow(wnd0Ptr);
while (GetMessage(&msg,NULL,0,0))
{
TranslateMessage(&msg);
DispatchMessage(&msg);
}
timer3_off();
timer2_off();
timer1_off();
timer0_off();
delete_dc();
}
else
MessageBox(NULL,"Could Not CreateDC!","  Print Job Manager",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
close_printer();
}
else
MessageBox(NULL,"Could Not OPEN The Printer!","  Print Job Manager",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);

if (curfont)
{
SelectObject(hdc,oldfont);
DeleteObject(curfont);
}

if (cursor_Handle)
DestroyCursor(cursor_Handle);

if (mutex_handle)
ReleaseMutex(mutex_handle);

return msg.wParam;

}
}
}
}
}
}
}
}
}
}

}
}
}
if (mutex_handle)
ReleaseMutex(mutex_handle);
}
else
{
MessageBox(NULL,"Already Running!     ","  Print Job Manager",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
return 1;
}
}
else
{
MessageBox(NULL,"Could Not CreateMutex()","  Print Job Manager",MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
return 1;
}
return 0;
}
